# phpMyAdmin MySQL-Dump
# version 2.2.6
# http://phpwizard.net/phpMyAdmin/
# http://www.phpmyadmin.net/ (download page)
#
# Host: localhost
# Generation Time: Oct 11, 2005 at 02:45 PM
# Server version: 3.23.49
# PHP Version: 4.2.0
# Database : `auracms162`
# --------------------------------------------------------

#
# Table structure for table `admin`
#

DROP TABLE IF EXISTS admin;
CREATE TABLE admin (
  id int(11) NOT NULL auto_increment,
  menu varchar(30) NOT NULL default '',
  url varchar(60) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY id (id)
) TYPE=MyISAM;

#
# Dumping data for table `admin`
#

INSERT INTO admin (id, menu, url) VALUES (2, 'Beranda Admin', 'admin2.php');
INSERT INTO admin (id, menu, url) VALUES (3, 'Edit Admin', 'admininfo.php');
INSERT INTO admin (id, menu, url) VALUES (4, 'Menu Manager', 'adminmenu.php');
INSERT INTO admin (id, menu, url) VALUES (5, 'Halaman Web Manager', 'adminhalaman.php');
INSERT INTO admin (id, menu, url) VALUES (6, 'Topik Manager', 'admintopik.php');
INSERT INTO admin (id, menu, url) VALUES (7, 'Artikel Masuk', 'adminberita.php');
INSERT INTO admin (id, menu, url) VALUES (8, 'Artikel Manager', 'artikeltopik.php');
INSERT INTO admin (id, menu, url) VALUES (9, 'Menulis Artikel', 'postberita.php');
INSERT INTO admin (id, menu, url) VALUES (10, 'Buku Tamu Manager', 'admingb.php');
INSERT INTO admin (id, menu, url) VALUES (11, 'Blok Manager', 'adminblok.php');
INSERT INTO admin (id, menu, url) VALUES (12, 'Modul Manager', 'adminmodul.php');
INSERT INTO admin (id, menu, url) VALUES (1, 'Logout', 'log.php?k=logout');
INSERT INTO admin (id, menu, url) VALUES (13, 'Image Manager', 'adminfiles.php');
INSERT INTO admin (id, menu, url) VALUES (14, 'Files Manager', 'files.php');
INSERT INTO admin (id, menu, url) VALUES (15, 'Admin Download', 'admindl.php');
INSERT INTO admin (id, menu, url) VALUES (16, 'Admin Links', 'adminlinks.php');
# --------------------------------------------------------

#
# Table structure for table `artikel`
#

DROP TABLE IF EXISTS artikel;
CREATE TABLE artikel (
  id int(11) NOT NULL auto_increment,
  judul varchar(100) NOT NULL default '',
  konten text NOT NULL,
  user varchar(30) NOT NULL default '',
  email varchar(50) NOT NULL default '',
  tgl varchar(14) NOT NULL default '',
  publikasi int(1) NOT NULL default '0',
  topik tinyint(11) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table `artikel`
#

INSERT INTO artikel (id, judul, konten, user, email, tgl, publikasi, topik) VALUES (1, 'auraCMS 1.5 telah dirilis', '<img src=images/art.gif align=left>auracms 1.5 telah selesai dirilis dengan banyak pembenahan di sana sini, terutama perubahan struktur direktori, konfigurasi, fungsi pencarian yang baru, image manager yang baru dengan file manager dan uploader-nya dan sebagainya.\r\nYang jelas di versi ini bug yang ada di versi sebelumnya dieliminasi sebanyak mungkin dan kemudahan instalasi masih tetap diprioritaskan.\r\nDiharapkan versi ini bisa berguna bagi para pemakainya.', 'admin', 'arif@ayo.kliksini.com', 'Tue,21,Sep,04', 1, 1);
INSERT INTO artikel (id, judul, konten, user, email, tgl, publikasi, topik) VALUES (2, 'auraCMS 1.6beta telah terbit', 'Untuk semua pengguna auraCMS 1.5rs diharapkan untuk mengupgrade ke versi terakhir ini, karena terdapat security patch pada versi akhir ini. Hal ini untuk menghindari adanya html script injection yang memungkinkan orang bisa login ke situs Anda.\r\n\r\nTerima kasih.', 'admin', 'admin@mysite.com', 'Mon,25,Apr,05', 1, 1);
INSERT INTO artikel (id, judul, konten, user, email, tgl, publikasi, topik) VALUES (3, 'AuraCMS 1.61 telah dirilis', 'Para pengguna auraCMS mungkin banyak yang sudah menunggu full versi dari auraCMS ini setelah versi beta yang sebelumnya.\r\n\r\nUntuk lebih jelasnya baca fitur terbaru di README.TXT atau BACASAYA.TXT.', 'admin', 'admin@mysite.com', 'Wed,13,Jul,05', 1, 1);
INSERT INTO artikel (id, judul, konten, user, email, tgl, publikasi, topik) VALUES (4, 'AuraCMS 1.62 telah selesai dirilis', 'Bagi pengguna AuraCMS versi 1.61, versi 1.62 ini hanyalah berisi sedikit perbaikan dari versi 1.61 dan adanya tambahan shoutbox manager untuk menghapus pesan singkat yang tidak diinginkan.\r\n\r\nSilahkan mencoba.', 'admin', 'admin@mysite.com', 'Tue,11,Oct,05', 1, 1);
# --------------------------------------------------------

#
# Table structure for table `blok`
#

DROP TABLE IF EXISTS blok;
CREATE TABLE blok (
  id tinyint(11) NOT NULL auto_increment,
  namablok varchar(30) NOT NULL default '',
  isi text NOT NULL,
  posisi tinyint(2) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table `blok`
#

INSERT INTO blok (id, namablok, isi, posisi) VALUES (1, 'Bikin Website ?', '<img src=images/art.gif>\r\nGampang dan murah, hubungi saja <b><a href=http://auracms.opensource-indonesia.com/?pilih=mail>081 5654 1632</a></b>', 1);
INSERT INTO blok (id, namablok, isi, posisi) VALUES (2, 'Sindikasi Berita', '<p align=center><br>\r\n<a href=rss.php><img src=images/xml_rss.gif border=0></a><br><br>\r\n<a href=./?pilih=html><img src=images/html-small.png border=0></a>\r\n<br>&nbsp;</p>\r\n', 1);
# --------------------------------------------------------

#
# Table structure for table `bukutamu`
#

DROP TABLE IF EXISTS bukutamu;
CREATE TABLE bukutamu (
  id int(10) NOT NULL auto_increment,
  sekarang varchar(12) default NULL,
  nama varchar(50) default NULL,
  email varchar(60) default NULL,
  homepage varchar(60) default NULL,
  alamat text,
  komentar text,
  jawab text NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table `bukutamu`
#

INSERT INTO bukutamu (id, sekarang, nama, email, homepage, alamat, komentar, jawab) VALUES (1, '21-Sep-2004', 'admin', 'arif@ayo.kliksini.com', 'http://www.semarang.tk', 'Semarang', 'Tes buku tamu :)', 'ok, berhasil!');
# --------------------------------------------------------

#
# Table structure for table `counter`
#

DROP TABLE IF EXISTS counter;
CREATE TABLE counter (
  id tinyint(11) NOT NULL auto_increment,
  ip text NOT NULL,
  counter int(11) NOT NULL default '0',
  hits int(11) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table `counter`
#

INSERT INTO counter (id, ip, counter, hits) VALUES (1, '127.0.0.1-', 5, 1684);
# --------------------------------------------------------

#
# Table structure for table `dl`
#

DROP TABLE IF EXISTS dl;
CREATE TABLE dl (
  nama varchar(255) NOT NULL default '',
  email varchar(255) NOT NULL default '',
  url varchar(80) NOT NULL default '',
  keterangan varchar(255) NOT NULL default '',
  tgl varchar(100) NOT NULL default '',
  hit int(7) NOT NULL default '0',
  broken int(7) NOT NULL default '0',
  tipe varchar(10) NOT NULL default '',
  id int(7) NOT NULL auto_increment,
  kid int(8) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table `dl`
#

INSERT INTO dl (nama, email, url, keterangan, tgl, hit, broken, tipe, id, kid) VALUES ('AuraCMS', 'arif@ayo.kliksini.com', 'http://www.auracms.opensource-indonesia.com/?pilih=dl&mod=yes', 'Software untuk membangun website dengan konten dinamis yang merupakan karya anak bangsa dan berlisensi GNU/GPL, free-simple-easy to use.', '22-Feb-2005', 22, 0, 'aktif', 2, 4);
INSERT INTO dl (nama, email, url, keterangan, tgl, hit, broken, tipe, id, kid) VALUES ('VCD Gear', 'arif@ayo.kliksini.com', 'http://www.vcdgear.com/files/vcdgear355.zip', 'Program Konversi bermacam-macam format video ke format MPG', '20-Apr-2005', 3, 0, 'aktif', 3, 1);
# --------------------------------------------------------

#
# Table structure for table `halaman`
#

DROP TABLE IF EXISTS halaman;
CREATE TABLE halaman (
  id int(11) NOT NULL auto_increment,
  judul varchar(80) NOT NULL default '',
  konten text NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table `halaman`
#

INSERT INTO halaman (id, judul, konten) VALUES (1, 'Selamat Datang di auraCMS', '<img src=images/hello.jpg align=left hspace=10>\r\nSelamat ...<p>\r\nAnda berhasil menginstalasi auraCMS.<br>\r\nSemoga bisa bermanfaat.<p>\r\nUntuk login pertama kali gunakan :<br>\r\nusername : <b>admin</b><br>\r\npassword : <b>abc</b><p>\r\nTerimakasih.');
INSERT INTO halaman (id, judul, konten) VALUES (2, 'Tentang auraCMS', '<b>AuraCMS</b> adalah hasil karya anak bangsa yang merupakan software CMS (Content Managemen System) untuk website yang berbasis PHP4 & MySQL berlisensi GPL (General Public License).\r\n<p>\r\nDengan bentuk yang sederhana dan mudah ini diharapkan dapat digunakan oleh pemakai yang masih pemula sekalipun.\r\n<p>\r\nDan tak lupa bahwa software ini mungkin tak semuanya memenuhi harapan pemakai, oleh karena itu diharapkan adanya kritikan, sumbangan pikiran atau mungkin bentuk modifikasi dari para pengguna sekalian baik berupa modul maupun perubahan-perubahan lainnya yang dapat menjadikan <b>auraCMS</b> ini menjadi lebih baik.\r\n<p>\r\nTerimakasih.<br>\r\n<b><a href=http://www.semarang.tk>SemarangKomunikasi</a></b>\r\n');
# --------------------------------------------------------

#
# Table structure for table `katdl`
#

DROP TABLE IF EXISTS katdl;
CREATE TABLE katdl (
  kategori varchar(255) NOT NULL default '',
  jumlah int(5) unsigned NOT NULL default '0',
  new int(11) NOT NULL default '0',
  id int(4) NOT NULL auto_increment,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table `katdl`
#

INSERT INTO katdl (kategori, jumlah, new, id) VALUES ('Freeware', 1, 0, 1);
INSERT INTO katdl (kategori, jumlah, new, id) VALUES ('E-Book Komputer', 0, 0, 2);
INSERT INTO katdl (kategori, jumlah, new, id) VALUES ('Shareware', 0, 0, 3);
INSERT INTO katdl (kategori, jumlah, new, id) VALUES ('CMS', 1, 0, 4);
INSERT INTO katdl (kategori, jumlah, new, id) VALUES ('CMS - Modul', 0, 0, 5);
INSERT INTO katdl (kategori, jumlah, new, id) VALUES ('CMS - Themes', 0, 0, 6);
# --------------------------------------------------------

#
# Table structure for table `katlink`
#

DROP TABLE IF EXISTS katlink;
CREATE TABLE katlink (
  kategori varchar(255) NOT NULL default '',
  jumlah int(5) unsigned NOT NULL default '0',
  new int(11) NOT NULL default '0',
  id int(4) NOT NULL auto_increment,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table `katlink`
#

INSERT INTO katlink (kategori, jumlah, new, id) VALUES ('Mesin Pencari', 2, 0, 1);
INSERT INTO katlink (kategori, jumlah, new, id) VALUES ('Pengguna AuraCMS', 0, 0, 2);
INSERT INTO katlink (kategori, jumlah, new, id) VALUES ('Portal', 0, 0, 3);
INSERT INTO katlink (kategori, jumlah, new, id) VALUES ('Pemerintahan', 0, 0, 4);
INSERT INTO katlink (kategori, jumlah, new, id) VALUES ('Seni & Budaya', 0, 0, 5);
INSERT INTO katlink (kategori, jumlah, new, id) VALUES ('Kenalan, Family & Keluarga', 0, 0, 6);
INSERT INTO katlink (kategori, jumlah, new, id) VALUES ('Agama', 0, 0, 7);
# --------------------------------------------------------

#
# Table structure for table `komentar`
#

DROP TABLE IF EXISTS komentar;
CREATE TABLE komentar (
  id int(11) NOT NULL auto_increment,
  judul varchar(90) NOT NULL default '',
  konten text NOT NULL,
  user varchar(30) NOT NULL default '',
  email varchar(50) NOT NULL default '',
  tgl varchar(14) NOT NULL default '',
  artikel int(11) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table `komentar`
#

INSERT INTO komentar (id, judul, konten, user, email, tgl, artikel) VALUES (1, 'tes komentar', 'semoga berhasil dengan versi barunya ...', 'admin', 'admin@mysite.com', 'Wed,13,Jul,05', 3);
# --------------------------------------------------------

#
# Table structure for table `links`
#

DROP TABLE IF EXISTS links;
CREATE TABLE links (
  nama varchar(255) NOT NULL default '',
  email varchar(255) NOT NULL default '',
  url varchar(80) NOT NULL default '',
  keterangan varchar(255) NOT NULL default '',
  tgl varchar(100) NOT NULL default '',
  hit int(7) NOT NULL default '0',
  broken int(7) NOT NULL default '0',
  tipe varchar(10) NOT NULL default '',
  id int(7) NOT NULL auto_increment,
  kid int(8) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table `links`
#

INSERT INTO links (nama, email, url, keterangan, tgl, hit, broken, tipe, id, kid) VALUES ('google', 'arif@ayo.kliksini.com', 'http://google.com', 'searh engin2l;kl ljkljhkl dc', '01-Apr-2005', 0, 0, 'aktif', 1, 1);
INSERT INTO links (nama, email, url, keterangan, tgl, hit, broken, tipe, id, kid) VALUES ('yahoo!', 'arif@ayo.kliksini.com', 'http://yahoo.com', 'dvev edv evd', '01-Apr-2005', 4, 0, 'aktif', 2, 1);
# --------------------------------------------------------

#
# Table structure for table `menu`
#

DROP TABLE IF EXISTS menu;
CREATE TABLE menu (
  id int(2) NOT NULL auto_increment,
  menu varchar(50) NOT NULL default '',
  url varchar(127) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table `menu`
#

INSERT INTO menu (id, menu, url) VALUES (1, 'Beranda', './');
INSERT INTO menu (id, menu, url) VALUES (2, 'Interaktif', '#');
# --------------------------------------------------------

#
# Table structure for table `modul`
#

DROP TABLE IF EXISTS modul;
CREATE TABLE modul (
  id tinyint(11) NOT NULL auto_increment,
  modul varchar(30) NOT NULL default '',
  isi varchar(50) NOT NULL default '',
  setup varchar(50) NOT NULL default '',
  posisi tinyint(2) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table `modul`
#

INSERT INTO modul (id, modul, isi, setup, posisi) VALUES (1, 'Pesan Singkat', 'shoutbox.php', 'shout_setup.php', 0);
INSERT INTO modul (id, modul, isi, setup, posisi) VALUES (3, 'Jajak Pendapat', 'poll_test.php', 'poll_setup.php', 1);
INSERT INTO modul (id, modul, isi, setup, posisi) VALUES (4, 'Kalender', 'calendar.php', '', 1);
INSERT INTO modul (id, modul, isi, setup, posisi) VALUES (6, 'Top Download', 'topdl.php', '', 1);
INSERT INTO modul (id, modul, isi, setup, posisi) VALUES (7, 'Link Terbaru', 'lastlink.php', '', 1);
INSERT INTO modul (id, modul, isi, setup, posisi) VALUES (8, 'Hari Ini', 'cuaca.php', '', 1);
INSERT INTO modul (id, modul, isi, setup, posisi) VALUES (9, 'Artikel Terakhir', 'terakhir.php', '', 1);
INSERT INTO modul (id, modul, isi, setup, posisi) VALUES (10, 'Statistik Web', 'stat.php', '', 0);
# --------------------------------------------------------

#
# Table structure for table `poll`
#

DROP TABLE IF EXISTS poll;
CREATE TABLE poll (
  id tinyint(11) NOT NULL auto_increment,
  isipoll text NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table `poll`
#

INSERT INTO poll (id, isipoll) VALUES (1, '<?/*^Bahasa PHP itu menurut Anda :^Gampang|Biasa|Susah|Bingung|Mbuh^0|0|0|0|1^|127.0.0.1^*/?>');
# --------------------------------------------------------

#
# Table structure for table `shoutbox`
#

DROP TABLE IF EXISTS shoutbox;
CREATE TABLE shoutbox (
  id tinyint(2) NOT NULL auto_increment,
  isi text NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table `shoutbox`
#

INSERT INTO shoutbox (id, isi) VALUES (1, 'arif||versi 1.62  :oo  |11-Oct-05 14:35 WIB\n$\narif||tes gitu ;-)  |11-Oct-05 14:33 WIB\r\n\n$\n\n$\n\n$\n\n$\n\n$\n\n$\n\n$\n\n$\n\n$\n\n$\n\n$\n\n$\n\n$\n\n$\n\n$\n\n$\n\n$\n\n$\n\n$\n\n$\n\n$\n\n$\n\n$\n\n$\n');
# --------------------------------------------------------

#
# Table structure for table `submenu`
#

DROP TABLE IF EXISTS submenu;
CREATE TABLE submenu (
  id int(2) NOT NULL auto_increment,
  menu varchar(50) NOT NULL default '',
  url varchar(127) NOT NULL default '',
  parent int(2) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table `submenu`
#

INSERT INTO submenu (id, menu, url, parent) VALUES (1, 'Tentang AuraCMS', './?pilih=hal&id=2', 1);
INSERT INTO submenu (id, menu, url, parent) VALUES (9, 'Download', './?pilih=dl&mod=yes', 1);
INSERT INTO submenu (id, menu, url, parent) VALUES (10, 'Web Links', './?pilih=links&mod=yes', 1);
INSERT INTO submenu (id, menu, url, parent) VALUES (11, 'Buku Tamu', './?pilih=gb', 2);
INSERT INTO submenu (id, menu, url, parent) VALUES (12, 'Rubrik', './?pilih=topik', 1);
INSERT INTO submenu (id, menu, url, parent) VALUES (13, 'Kirim Artikel', './?pilih=berita', 2);
INSERT INTO submenu (id, menu, url, parent) VALUES (14, 'Kontak Kami', './?pilih=mail', 2);
INSERT INTO submenu (id, menu, url, parent) VALUES (15, 'SMS Kami', './?pilih=hal&id=4', 2);
# --------------------------------------------------------

#
# Table structure for table `topik`
#

DROP TABLE IF EXISTS topik;
CREATE TABLE topik (
  id tinyint(11) NOT NULL auto_increment,
  topik varchar(60) NOT NULL default '',
  ket text NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table `topik`
#

INSERT INTO topik (id, topik, ket) VALUES (1, 'AuraCMS', 'Semua tentang auraCMS: berita, update, trouble shooter dan pengembangannya ');
INSERT INTO topik (id, topik, ket) VALUES (5, 'Komputer dan Internet', 'Berita tentang dunia komputer, hardware, software serta dunia internet');
INSERT INTO topik (id, topik, ket) VALUES (6, 'Bisnis dan Ekonomi', 'Berita tentang bisnis dan ekonomi');
INSERT INTO topik (id, topik, ket) VALUES (7, 'Seni dan Budaya', 'Tentang dunia seni, hiburan dan budaya');
INSERT INTO topik (id, topik, ket) VALUES (8, 'Sosial dan Politik', 'Tentang khidupan sosial dan informasi politik');
INSERT INTO topik (id, topik, ket) VALUES (9, 'Olahraga', 'Berita dari dunia olahraga');
INSERT INTO topik (id, topik, ket) VALUES (10, 'Sain dan Teknologi', 'Berita tentang teknologi baru yang berguna');
# --------------------------------------------------------

#
# Table structure for table `user`
#

DROP TABLE IF EXISTS user;
CREATE TABLE user (
  id int(11) NOT NULL auto_increment,
  user varchar(20) NOT NULL default '',
  email varchar(40) NOT NULL default '',
  password varchar(32) NOT NULL default '',
  ket text NOT NULL,
  tipe int(11) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

#
# Dumping data for table `user`
#

INSERT INTO user (id, user, email, password, ket, tipe) VALUES (1, 'admin', 'admin@mysite.com', 'YWJj', 'cG93ZXJlZCBieSA8YSBocmVmPWh0dHA6Ly9hdXJhY21zLm9wZW5zb3VyY2UtaW5kb25lc2lhLmNvbT5hdXJhfENNU3w8L2E+ ', 1);

